(require 'widget)
     
(eval-when-compile
  (require 'wid-edit))
     
(defvar widget-example-repeat)
     
(defun widget-example ()
  "Create the widgets from the Widget manual."
  (interactive)
  (kill-buffer (get-buffer-create "*Widget Example*"))
  (switch-to-buffer (get-buffer-create "*Widget Example*"))
  (kill-all-local-variables)
  (make-local-variable 'widget-example-repeat)
  (widget-insert "Here is some documentation.\n\nName: ")
  (set (make-local-variable 'ef1)
       (widget-create 'editable-field
		      :size 13
		      "My Name"))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active ef1)
		      (widget-specify-inactive
		       ef1
		       (widget-get ef1 :from)
		       (widget-get ef1 :to))))
		 t)
  (widget-insert "\n")
  (set (make-local-variable 'mc1)
       (widget-create 'menu-choice
		      :tag "Choose"
		      :value "This"
		      :help-echo "Choose me, please!"
		      :notify (lambda (widget &rest ignore)
				(message "%s is a good choice!"
					 (widget-value widget)))
		      '(item :tag "This option" :value "This")
		      '(choice-item "That option")
		      '(editable-field :menu-tag "No option" "Thus option")))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active mc1)
		      (widget-specify-inactive
		       mc1
		       (widget-get mc1 :from)
		       (widget-get mc1 :to))))
		 t)
  (widget-insert "\n")
  (widget-insert "Address: ")
  (set (make-local-variable 'ef2)
       (widget-create 'editable-field
		      "Some Place\nIn some City\nSome country."))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active ef2)
		      (widget-specify-inactive
		       ef2
		       (widget-get ef2 :from)
		       (widget-get ef2 :to))))
		 t)
  (widget-insert "\n")
  (widget-insert "\nSee also ")
  (set (make-local-variable 'l1)
       (widget-create 'link
		      :notify (lambda (&rest ignore)
				(widget-value-set widget-example-repeat
						  '("En" "To" "Tre"))
				(widget-setup))
		      "other work"))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active l1)
		      (widget-specify-inactive
		       l1
		       (widget-get l1 :from)
		       (widget-get l1 :to))))
		 t)
  (widget-insert "\n")
  (widget-insert " for more information.\n\nNumbers: count to three below\n")
  (setq widget-example-repeat
     	(widget-create 'editable-list
     		       :entry-format "%i %d %v"
     		       :notify (lambda (widget &rest ignore)
     				 (let ((old (widget-get widget
     							':example-length))
     				       (new (length (widget-value widget))))
     				   (unless (eq old new)
     				     (widget-put widget ':example-length new)
     				     (message "You can count to %d." new))))
     		       :value '("One" "Eh, two?" "Five!")
     		       '(editable-field :value "three")))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active widget-example-repeat)
		      (widget-specify-inactive
		       widget-example-repeat
		       (widget-get widget-example-repeat :from)
		       (widget-get widget-example-repeat :to))))
		 t)
  (widget-insert "\n")
  (widget-insert "\n\nSelect multiple:\n\n")
  (set (make-local-variable 'cb1)
       (widget-create 'checkbox t))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active cb1)
		      (widget-specify-inactive
		       cb1
		       (widget-get cb1 :from)
		       (widget-get cb1 :to))))
		 t)
  (widget-insert "\n")
  (widget-insert " This\n")
  (set (make-local-variable 'cb2)
       (widget-create 'checkbox nil))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active cb2)
		      (widget-specify-inactive
		       cb2
		       (widget-get cb2 :from)
		       (widget-get cb2 :to))))
		 t)
  (widget-insert "\n")
  (widget-insert " That\n")
  (set (make-local-variable 'cb3)
       (widget-create 'checkbox
		      :notify (lambda (&rest ignore) (message "Tickle"))
		      t))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active cb3)
		      (widget-specify-inactive
		       cb3
		       (widget-get cb3 :from)
		       (widget-get cb3 :to))))
		 t)
  (widget-insert "\n")
  (widget-insert " Thus\n\nSelect one:\n\n")
  (set (make-local-variable 'rbc1)
       (widget-create 'radio-button-choice
		      :value "One"
		      :notify (lambda (widget &rest ignore)
				(message "You selected %s"
					 (widget-value widget)))
		      '(item "One") '(item "Another One.") '(item "A Final One.")))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active rbc1)
		      (widget-specify-inactive
		       rcb1
		       (widget-get rbc1 :from)
		       (widget-get rbc1 :to))))
		 t)
  (widget-insert "\n")
  (widget-insert "\n")
  (set (make-local-variable 'pb1)
       (widget-create 'push-button
		      :notify (lambda (&rest ignore)
				(if (= (length (widget-value widget-example-repeat))
				       3)
				    (message "Congratulation!")
				  (error "Three was the count!")))
		      "Apply Form"))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active pb1)
		      (widget-specify-inactive
		       pb1
		       (widget-get pb1 :from)
		       (widget-get pb1 :to))))
		 t)
  (widget-insert "\n")
  (widget-insert " ")
  (set (make-local-variable 'pb2)
       (widget-create 'push-button
		      :notify (lambda (&rest ignore)
				(widget-example))
		      "Reset Form"))
  (widget-insert "\n")
  (widget-create 'toggle
		 :on "active"
		 :off "inactive"
		 :notify
		 '(lambda (widget &rest ignore)
		    (if (widget-value widget)
			(widget-specify-active pb2)
		      (widget-specify-inactive
		       pb2
		       (widget-get pb2 :from)
		       (widget-get pb2 :to))))
		 t)
  (widget-insert "\n")
  (widget-insert "\n")
  (use-local-map widget-keymap)
  (widget-setup))
